#ifdef GL_ES
	precision mediump float;
#endif

varying vec2 v_texCoord;
varying vec4 v_posCoord;

uniform vec2 u_shiftPos;
uniform vec2 u_constSizePalette;
uniform vec2 u_sizePalette;
uniform float u_fogTextureSize;
uniform vec2 u_posPalette;
uniform float u_globalAlpha;
uniform mat4 u_fogMatrix;
uniform vec4 u_scissorsRect;

uniform sampler2D u_texture;
uniform sampler2D u_palette; 

vec4 sharpedAlpfa(vec4 fragColor, float koefSharped) {
	vec4 res = fragColor;
	res.a -= 0.5;
	res.a /= koefSharped;
	res.a += 0.5;
	
	if ( res.a < 0.0 ) {
		res.a = 0.0;
	} else if ( res.a > 1.0 ) {
		res.a = 1.0;
	}
	
	return res;
}

void main() {
	vec2 v1 = vec2(0.7,-0.7);
	vec4 vf = u_fogMatrix * vec4(v_posCoord.x, v_posCoord.y, 1.0, 1.0);
	//vf = vec4(vf.x, vf.y, 0.0, 1.0);
	
	vec2 vftex = vf.xy / u_fogTextureSize;
	vec4 colorCurr = sharpedAlpfa(texture2D(u_texture, vftex ),0.35);
	vec4 colorPrev = sharpedAlpfa(texture2D(u_texture, vftex - 0.005 * v1 ),0.8);
	
	vec2 q = fract( v_posCoord.xy / u_sizePalette.xy + u_shiftPos) * u_constSizePalette + u_posPalette;

	gl_FragColor = texture2D(u_palette, q);
	gl_FragColor.a = 1.0 - colorCurr.a;

	
	float blackoutKoef = 0.5;
	if ( colorCurr.a - colorPrev.a > 0.0 ) {
		float currFogAlfa = 1.0 - colorCurr.a;
		float prevFogAlfa = 1.0 - colorPrev.a;
		if ( gl_FragColor.a > 0.0 ){
			float koef = blackoutKoef * prevFogAlfa;
			gl_FragColor = vec4( gl_FragColor.r * gl_FragColor.a , gl_FragColor.g * gl_FragColor.a , gl_FragColor.b * gl_FragColor.a , gl_FragColor.a * (1.0 - koef) + koef );  
			//gl_FragColor = vec4(0.0,1.0,0.0, blackoutKoef);
		} else {
			if ( prevFogAlfa == 1.0 ) {
				gl_FragColor = vec4(0.0, 0.0, 0.0, blackoutKoef);
				//gl_FragColor = vec4(1.0,0.0,0.0, blackoutKoef);
			} else {
				gl_FragColor = vec4(0.0, 0.0, 0.0, prevFogAlfa * blackoutKoef);
				//gl_FragColor = vec4(0.0,0.0,1.0, blackoutKoef);			
			}
		}			
	}

	gl_FragColor.a *= u_globalAlpha;
}

