#ifdef GL_ES
	precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
varying vec4 absolutePos;

uniform sampler2D u_texture;
uniform vec4 u_scissorsRect;

bool isInScissorsRect(vec4 position) {
	return ( position.x >= u_scissorsRect.x && position.x <= u_scissorsRect.z
	  && position.y >= u_scissorsRect.y && position.y <= u_scissorsRect.w ) ;
}
 
void main()
{
	if ( isInScissorsRect( absolutePos ) ) {
		gl_FragColor = v_fragmentColor * texture2D(u_texture, v_texCoord );
	} else {
		gl_FragColor = vec4(0.0,0.0,0.0,0.0);
	}
}
