#ifdef GL_ES
	precision mediump float;
#endif

varying vec2 v_texCoord;
varying vec4 pos;
varying vec4 absolutePos;
varying vec4 v_fragmentColor;	

uniform float u_thicknessBorder;
uniform float u_borderAlpfa;
uniform float u_opacity;
uniform bool u_enableRectScissorZone;
uniform bool u_enableWaterScissor;
uniform vec4 u_rectScissorZone;

uniform sampler2D CC_Texture0;

bool isInScissorsRect(vec4 position) {
	return ( position.x >= u_rectScissorZone.x && position.x <= u_rectScissorZone.z
	  && position.y >= u_rectScissorZone.y && position.y <= u_rectScissorZone.w ) ;
}

void main() {
	if ( u_enableRectScissorZone && !isInScissorsRect( absolutePos ) ) {
		gl_FragColor = vec4( 0.0, 0.0, 0.0, 0.0 );
		return;
	}
	
	gl_FragColor = v_fragmentColor * texture2D(CC_Texture0,v_texCoord);	
	
	if ( u_enableWaterScissor ) {
		float y = pos.y;
		if ( y < u_borderAlpfa + u_thicknessBorder ) {
			if ( y < u_borderAlpfa - u_thicknessBorder ) {
				gl_FragColor = vec4( 0.0, 0.0, 0.0, 0.0);
			} else {
				float q = ( y - ( u_borderAlpfa - u_thicknessBorder) ) / ( u_thicknessBorder * 2.0 );
				gl_FragColor = vec4( gl_FragColor.r * q, gl_FragColor.g * q, gl_FragColor.b * q, gl_FragColor.a * q);
			}
		} else {
			gl_FragColor = vec4( gl_FragColor.r * u_opacity, gl_FragColor.g * u_opacity, gl_FragColor.b * u_opacity, gl_FragColor.a * u_opacity);
		}
	}
}
